//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  DeepSkyBlue
#property indicator_color2  PaleVioletRed
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern string ForSymbol       = "";
extern int    MaPeriod        = 14;
extern int    MaShift         = 0;
extern int    MaMethod        = MODE_LWMA;
extern int    UpperPrice      = PRICE_CLOSE;
extern int    LowerPrice      = PRICE_CLOSE;
extern double Deviation       = 0.2;
extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;

//
//
//
//
//

double UpLine[];
double DnLine[]; 
double smax[];
double smin[];
double trend[];

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
      SetIndexBuffer(0,UpLine); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,DnLine); SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,smax);
      SetIndexBuffer(3,smin);
      SetIndexBuffer(4,trend);
      if (ForSymbol == "") ForSymbol = Symbol();   
   
      //
      //
      // 
      //
      //

         MaPeriod          = MathMax(MaPeriod,2);
         Deviation         = MathMax(MathMin(Deviation,100),0.0);
         indicatorFileName = WindowExpertName();
         calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
         returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
 
         for (int i=0;i<4;i++) SetIndexShift(i,MaShift*timeFrame/Period());
   IndicatorShortName(ForSymbol+" "+timeFrameToString(timeFrame)+" "+getAverageName(MaMethod)+" trend envelopes("+MaPeriod+")");
   return(0);
}
 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { UpLine[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || (ForSymbol == Symbol() && timeFrame==Period()))
   {
      for(i=limit; i>=0; i--)
      { 
         smax[i]    = (1+Deviation/100)*iCustomMA(iMA(NULL,0,1,0,MODE_SMA,UpperPrice,i),MaPeriod,MaMethod,i,0);
         smin[i]    = (1-Deviation/100)*iCustomMA(iMA(NULL,0,1,0,MODE_SMA,LowerPrice,i),MaPeriod,MaMethod,i,1);
         UpLine[i]  = EMPTY_VALUE;
         DnLine[i]  = EMPTY_VALUE;
         trend[i]   = trend[i+1]; 
   
         //
         //
         //
         //
         //
         
	      if (Close[i]>smax[i+1]) trend[i]= 1; 
	      if (Close[i]<smin[i+1]) trend[i]=-1;
	      if (trend[i]>0 && smin[i]<smin[i+1]) smin[i]=smin[i+1];
	      if (trend[i]<0 && smax[i]>smax[i+1]) smax[i]=smax[i+1];
         if (trend[i] == 1) UpLine[i] = 1;
         if (trend[i] ==-1) DnLine[i] = 1;
      }
      manageAlerts();
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars,iCustom(ForSymbol,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0; i--)
   {
      int y = iBarShift(ForSymbol,timeFrame,Time[i]);
         UpLine[i]  = iCustom(ForSymbol,timeFrame,indicatorFileName,"calculateValue","",MaPeriod,MaShift,MaMethod,UpperPrice,LowerPrice,Deviation,0,y);
         DnLine[i]  = iCustom(ForSymbol,timeFrame,indicatorFileName,"calculateValue","",MaPeriod,MaShift,MaMethod,UpperPrice,LowerPrice,Deviation,1,y);
   }
   manageAlerts();
   return(0);         
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double workPrices[][2];
double workResult[][2];
int    r;

double iCustomMA(double price, int period, int method, int i, int forValue=0 )
{
   if (ArrayRange(workPrices,0)!= Bars) ArrayResize(workPrices,Bars);
            r = Bars-i-1;
   workPrices[r][forValue] = price;

   //
   //
   //
   //
   //
   
      switch(method)
      {
         case  0: return(iSma(price,period,i,forValue));
         case  1: return(iEma(price,period,i,forValue));
         case  2: return(iSmma(price,period,i,forValue));
         case  3: return(iLwma(price,period,i,forValue));
         case  4: return(iLsma(price,period,i,forValue));
         case  5: return(iTma(price,period,i,forValue));
         case  6: return(iSineWMA(price,period,i,forValue));
         case  7: return(iVolumeWMA(price,period,i,forValue));
         case  8: return(iHma(price,period,i,forValue));
         case  9: return(iNonLagMa(price,period,i,forValue));
      }
   return(EMPTY_VALUE);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double iSma(double price, double period, int i, int s=0)
{
   double sum = 0;
   for(int k=0; k<period && (r-k)>=0; k++) sum += workPrices[r-k][s];  
   if (k!=0)
         return(sum/k);
   else  return(EMPTY_VALUE);
}

//
//
//
//
//

double iEma(double price, double period, int i, int s=0)
{
   if (ArrayRange(workResult,0)!= Bars) ArrayResize(workResult,Bars);
   double alpha = 2.0 / (1.0+period);
          workResult[r][s] = workResult[r-1][s]+alpha*(price-workResult[r-1][s]);
   return(workResult[r][s]);
}
//
//
//
//
//

double iSmma(double price, double period, int i, int s=0)
{
   if (ArrayRange(workResult,0)!= Bars) ArrayResize(workResult,Bars);
   if (i>=(Bars-period))
   {
      double sum = 0; 
         for(int k=0; k<period && (r-k)>=0; k++) sum += workPrices[r-k][s];  
         if (k!=0)
               workResult[r][s] = sum/k;
         else  workResult[r][s] = EMPTY_VALUE;
   }      
   else   workResult[r][s] = (workResult[r-1][s]*(period-1)+price)/period;
   return(workResult[r][s]);
}

//
//
//
//
//

double iLwma.prices[][6];
double iLwma(double price, double period, int i, int s=0)
{
   if (ArrayRange(iLwma.prices,0)!= Bars) ArrayResize(iLwma.prices,Bars);
   
   //
   //
   //
   //
   //
   
   iLwma.prices[r][s] = price;
      double sum  = 0;
      double sumw = 0;

      for(int k=0; k<period && (r-k)>=0; k++)
      {
         double weight = period-k;
                sumw  += weight;
                sum   += weight*iLwma.prices[r-k][s];  
      }             
   if (sumw!=0)
         return(sum/sumw);
   else  return(EMPTY_VALUE);
}

//
//
//
//
//

double iLsma(double price, double period, int i, int s=0)
{
   return(3.0*iLwma(price,period,i,s)-2.0*iSma(price,period,i,s));
}

//
//
//
//
//

double iHma(double price, double period, int i, int s=0)
{
   int HalfPeriod = MathFloor(period/2);
   int HullPeriod = MathFloor(MathSqrt(period));
            double price1 = 2.0*iLwma(price,HalfPeriod,i,s*3+0)-iLwma(price,period,i,s*3+1);
   return (iLwma(price1,HullPeriod,i,s*3+2));
}

//
//
//
//
//

double iTma(double price, double period, int i, int s=0)
{
   double half = (period+1.0)/2.0;
   double sum  = 0;
   double sumw = 0;

   for(int k=0; k<period && (r-k)>=0; k++)
   {
      double weight = k+1; if (weight > half) weight = period-k;
             sumw  += weight;
             sum   += weight*workPrices[r-k][s];  
   }             
   if (sumw!=0)
         return(sum/sumw);
   else  return(EMPTY_VALUE);
}

//
//
//
//
//

#define Pi 3.14159265358979323846
double iSineWMA(double price, int period, int i, int s=0)
{
   double sum  = 0;
   double sumw = 0;
  
   for(int k=0; k<period && (r-k)>=0; k++)
   { 
      double weight = MathSin(Pi*(k+1)/(period+1));
             sumw  += weight;
             sum   += weight*workPrices[r-k][s]; 
   }
   if (sumw!=0)
         return(sum/sumw);
   else  return(EMPTY_VALUE);
}

//
//
//
//
//

double iVolumeWMA(double price, int period, int i, int s=0)
{
   double sum  = 0;
   double sumw = 0;
  
   for(int k=0; k<period && (r-k)>=0; k++)
   { 
      double weight = Volume[i+k];
             sumw  += weight;
             sum   += weight*workPrices[r-k][s]; 
   }
   if (sumw!=0)
         return(sum/sumw);
   else  return(EMPTY_VALUE);
}


//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

#define Pi       3.14159265358979323846264338327950288
#define _length  0
#define _len     1
#define _weight  2

#define numOfSeparateCalculations 2
double  nlm.values[3][numOfSeparateCalculations];
double  nlm.prices[ ][numOfSeparateCalculations];
double  nlm.alphas[ ][numOfSeparateCalculations];

//
//
//
//
//

double iNonLagMa(double price, int length, int i, int s=0)
{
   if (ArrayRange(nlm.prices,0) != Bars) ArrayResize(nlm.prices,Bars);
            int r = Bars-i-1;  nlm.prices[r][s]=price;
   if (length<3 || r<3) return(nlm.prices[r][s]);
   
   //
   //
   //
   //
   //
   
   if (nlm.values[_length][s] != length)
   {
      double Cycle = 4.0;
      double Coeff = 3.0*Pi;
      int    Phase = length-1;
      
         nlm.values[_length][s] = length;
         nlm.values[_len   ][s] = length*4 + Phase;  
         nlm.values[_weight][s] = 0;

         if (ArrayRange(nlm.alphas,0) < nlm.values[_len][s]) ArrayResize(nlm.alphas,nlm.values[_len][s]);
         for (int k=0; k<nlm.values[_len][s]; k++)
         {
            if (k<=Phase-1) 
                 double t = 1.0 * k/(Phase-1);
            else        t = 1.0 + (k-Phase+1)*(2.0*Cycle-1.0)/(Cycle*length-1.0); 
            double beta = MathCos(Pi*t);
            double g = 1.0/(Coeff*t+1); if (t <= 0.5 ) g = 1;
      
            nlm.alphas[k][s]        = g * beta;
            nlm.values[_weight][s] += nlm.alphas[k][s];
         }
   }
   
   //
   //
   //
   //
   //
   
   if (nlm.values[_weight][s]>0)
   {
      double sum = 0;
           for (k=0; k < nlm.values[_len][s]; k++) sum += nlm.alphas[k][s]*nlm.prices[r-k][s];
           return( sum / nlm.values[_weight][s]);
   }
   else return(0);           
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string methodNames[] = {"SMA","EMA","SMMA","LWMA","LSMA","TriMA","SWMA","VWMA","HullMA","NonLagMA"};
string getAverageName(int& method)
{
   method=MathMax(MathMin(method,9),0); return(methodNames[method]);
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(ForSymbol,0,iTime(ForSymbol,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(whichBar,"up");
         if (trend[whichBar] == -1) doAlert(whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(ForSymbol," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," ",getAverageName(MaMethod)," trend envelope changed to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),getAverageName(MaMethod)),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}